Index: scripts/Makefile.am
===================================================================
--- scripts/Makefile.am	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/Makefile.am	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,34 @@
+AUTOMAKE_OPTIONS = foreign
+
+SUBDIRS = . binutils gccnewlib
+
+noinst_SCRIPTS = \
+setup \
+buildall \
+mkbinutils_subpackage_version \
+mkbinutilspec \
+mkbspspec \
+mkgccnewlibspec \
+mkgdbspec \
+mkrpms \
+mkspec \
+mktoolspec
+
+TEMPLATES = \
+gccnewlib.spec.in \
+gdb.spec.in \
+rtems.spec.in \
+toolchain.spec.in
+
+noinst_DATA = \
+setup.def $(TEMPLATES)
+
+EXTRA_DIST = \
+$(noinst_DATA) \
+$(noinst_SCRIPTS)
+
+CONFIGURE_DEPENDENCIES = setup.cache
+setup.cache: setup.def
+	cp setup.def $@
+
+DISTCLEANFILES = setup.cache
Index: scripts/TODO
===================================================================
--- scripts/TODO	(revision 1410dc36c7be2618992a5c1a6770ae8958bfe33f)
+++ scripts/TODO	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -1,7 +1,1 @@
 
-use mk* to insert tool version numbers. :)
-
-make gcc/newlib work
-
-write gdb one.
-  /opt/rtems/@target_alias@/include/readline*
Index: scripts/binutils/Makefile.am
===================================================================
--- scripts/binutils/Makefile.am	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/binutils/Makefile.am	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,50 @@
+AUTOMAKE_OPTIONS = foreign
+
+MKBINUTILSSPEC = $(SHELL) $(top_srcdir)/mkbinutilspec
+
+MKBINUTILSSPEC_DEPS = ../mkbinutilspec binutils.spec.in ../setup.cache
+
+i386-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . i386-rtems
+
+sh-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . sh-rtems
+
+powerpc-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . powerpc-rtems
+
+sparc-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . sparc-rtems
+
+m68k-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . m68k-rtems
+
+mips64orion-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . mips64orion-rtems
+
+i960-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . i960-rtems
+
+hppa1.1-rtems-$(BINUTILSVERS).spec: $(MKBINUTILSSPEC_DEPS)
+	$(MKBINUTILSSPEC) -cfg ../setup.cache -o . hppa1.1-rtems
+
+TEMPLATES = \
+binutils.spec.in
+
+RPM_SPECS_DATA = \
+i386-rtems-$(BINUTILSVERS).spec \
+sh-rtems-$(BINUTILSVERS).spec \
+powerpc-rtems-$(BINUTILSVERS).spec \
+sparc-rtems-$(BINUTILSVERS).spec \
+m68k-rtems-$(BINUTILSVERS).spec \
+mips64orion-rtems-$(BINUTILSVERS).spec \
+i960-rtems-$(BINUTILSVERS).spec \
+hppa1.1-rtems-$(BINUTILSVERS).spec
+
+noinst_DATA = \
+$(TEMPLATES)
+
+EXTRA_DIST = \
+$(TEMPLATES)
+
+CLEANFILES = $(RPM_SPECS_DATA)
Index: scripts/binutils/binutils.spec.in
===================================================================
--- scripts/binutils/binutils.spec.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/binutils/binutils.spec.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,152 @@
+#
+# spec file for package rtems
+# 
+# Copyright  (c)  1999  OARCorp, Huntsville, AL
+#
+# please send bugfixes or comments to joel@OARcorp.com
+#
+
+Vendor:       OAR Corporation
+Distribution: Linux
+Name:         @target_alias@-binutils
+Release:      @Release@
+Copyright:    1999 OARCorp
+Group:        unsorted
+Provides:     @target_alias@-binutils
+
+Autoreqprov:  	on
+Packager:     	corsepiu@faw.uni-ulm.de and joel@OARcorp.com
+Buildroot:    	/tmp
+Prefix:		/opt
+
+Version:      	binutils@binutils_version@
+Summary:      	binutils for target @target_alias@
+Source0:      	binutils-@binutils_version@.tar.gz
+Patch0:		binutils-@binutils_version@-rtems-@binutils_patch_version@.diff
+
+%description
+RTEMS is an open source operating system for embedded systems.
+
+This is the GNU binutils for RTEMS targetting @target_alias@.
+
+Authors:
+--------
+    Joel Sherrill (joel@oarcorp.com)
+    ...
+
+%prep
+# untar the sources inside @target_alias@-binutils
+%setup -c -n @target_alias@-binutils -a 0
+
+%patch0 -p0
+
+%build
+  test -d build || mkdir build
+  cd build
+  ../binutils-@binutils_version@/configure --target=@target_alias@ \
+    --verbose --prefix=/opt/rtems 
+
+  make all
+  make info
+
+%install
+  cd build
+  make prefix=$RPM_BUILD_ROOT/opt/rtems install
+  make prefix=$RPM_BUILD_ROOT/opt/rtems install-info
+# A bug in binutils: binutils does not install share/locale
+# however it uses it
+  ../binutils-@binutils_version@/mkinstalldirs \
+    $RPM_BUILD_ROOT/opt/rtems/share/locale
+
+# gzip info files
+  gzip -f $RPM_BUILD_ROOT/opt/rtems/info/*.info 2>/dev/null
+  gzip -f $RPM_BUILD_ROOT/opt/rtems/info/*.info-? 2>/dev/null
+
+  if test -f $RPM_BUILD_ROOT/opt/rtems/info/configure.info.gz;
+  then
+# These are only present in binutils >= 2.9.5
+    find $RPM_BUILD_ROOT/opt/rtems/info -name 'configure.*' | \
+      sed -e "s,^$RPM_BUILD_ROOT,,g" > ../files
+  else
+    touch ../files
+  fi
+
+%post
+  if test -d $RPM_INSTALL_PREFIX/rtems/info; 
+  then
+    rm -f $RPM_INSTALL_PREFIX/rtems/info/dir
+    f=`find $RPM_INSTALL_PREFIX/rtems/info -name '*.info.gz'`
+    test -n "$f" && for i in $f; do
+      install-info $i $RPM_INSTALL_PREFIX/rtems/info/dir
+    done
+  fi
+
+%postun
+  if test -d $RPM_INSTALL_PREFIX/rtems/info; 
+  then
+    rm -f $RPM_INSTALL_PREFIX/rtems/info/dir
+    f=`find $RPM_INSTALL_PREFIX/rtems/info -name '*.info.gz'`
+    test -n "$f" && for i in $f; do
+      install-info $i $RPM_INSTALL_PREFIX/rtems/info/dir
+    done
+  fi
+
+%files -f files
+%dir /opt/rtems/info
+%doc /opt/rtems/info/dir
+%doc /opt/rtems/info/as.info.gz
+%doc /opt/rtems/info/as.info-?.gz
+%doc /opt/rtems/info/bfd.info.gz
+%doc /opt/rtems/info/bfd.info-?.gz
+%doc /opt/rtems/info/binutils.info.gz
+%doc /opt/rtems/info/binutils.info-?.gz
+%doc /opt/rtems/info/ld.info.gz
+%doc /opt/rtems/info/ld.info-?.gz
+%doc /opt/rtems/info/gasp.info.gz
+%doc /opt/rtems/info/standards.info.gz
+
+%dir /opt/rtems/man
+%dir /opt/rtems/man/man1
+%doc /opt/rtems/man/man1/@target_alias@-*.1
+
+%dir /opt/rtems/bin
+/opt/rtems/bin/@target_alias@-addr2line
+/opt/rtems/bin/@target_alias@-ar
+/opt/rtems/bin/@target_alias@-as
+/opt/rtems/bin/@target_alias@-c++filt
+/opt/rtems/bin/@target_alias@-gasp
+/opt/rtems/bin/@target_alias@-ld
+/opt/rtems/bin/@target_alias@-nm
+/opt/rtems/bin/@target_alias@-objcopy
+/opt/rtems/bin/@target_alias@-objdump
+/opt/rtems/bin/@target_alias@-ranlib
+/opt/rtems/bin/@target_alias@-readelf
+/opt/rtems/bin/@target_alias@-size
+/opt/rtems/bin/@target_alias@-strings
+/opt/rtems/bin/@target_alias@-strip
+
+%dir /opt/rtems/include
+/opt/rtems/include/bfd.h
+/opt/rtems/include/ansidecl.h
+/opt/rtems/include/bfdlink.h
+
+%dir /opt/rtems/lib
+/opt/rtems/lib/libbfd*
+/opt/rtems/lib/libiberty*
+/opt/rtems/lib/libopcodes*
+
+%dir /opt/rtems/share
+%dir /opt/rtems/share/locale
+
+%dir /opt/rtems/@target_alias@
+%dir /opt/rtems/@target_alias@/bin
+/opt/rtems/@target_alias@/bin/ar
+/opt/rtems/@target_alias@/bin/as
+/opt/rtems/@target_alias@/bin/ld
+/opt/rtems/@target_alias@/bin/nm
+/opt/rtems/@target_alias@/bin/ranlib
+/opt/rtems/@target_alias@/bin/strip
+
+%dir /opt/rtems/@target_alias@/lib
+%dir /opt/rtems/@target_alias@/lib/ldscripts
+/opt/rtems/@target_alias@/lib/ldscripts/*
Index: scripts/buildall
===================================================================
--- scripts/buildall	(revision 1410dc36c7be2618992a5c1a6770ae8958bfe33f)
+++ scripts/buildall	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -3,6 +3,4 @@
 #  Generate all the specs and then cycle through building them.
 #
-
-RTEMS_DIR=`dirname $0`
 
 # This is the full list .. hppa1.1 does not build now.
@@ -18,36 +16,5 @@
 # This is what we are building this time
 #TARGETS=${ALL_TARGETS}
-TARGETS="sh-rtems"
-
-testing=no
-
-binutils=990901
-gcc=2.95.1
-gdb=4.18
-newlib=1.8.2
-buildroot=/opt/tmp
-
-#
-#  Now get started
-#
-start=`date`
-
-
-echo PATH=$PATH
-
-if [ ${testing} = yes ] ; then
-  ECHO=echo
-fi
-
-installed_count=`rpm -qa | grep rtems | wc -l`
-if [ ${installed_count} -ne 0 ] ; then
-  echo This script should be run with NO rtems RPMs installed.
-  echo It appears that the following rtems RPMs are installed:
-  echo
-  rpm -qa | grep rtems
-  echo
-  echo Please remove these and restart this script.
-  exit 1
-fi
+TARGETS="i386-rtems m68k-rtems powerpc-rtems sh-rtems"
 
 # Some linux distributions use /usr/src/packages
@@ -68,5 +35,5 @@
 for target in ${TARGETS}
 do
-  ${ECHO} ${RTEMS_DIR}/mkspec ${target}
+  ./mkspec ${target}
 done
 
@@ -75,71 +42,33 @@
 test -d log || mkdir log
 
-
-#  do all the tools
+#  do all the binutils
 for target in ${TARGETS}
 do
-  logfile=log/${target}-binutils
-  specfile=${dst}/${target}-binutils-${binutils}.spec
-  echo "rpm -ba --buildroot=${buildroot} ${specfile} >${logfile} 2>&1"
-  if [ ${testing} = no ] ; then
-    rpm -ba --buildroot=${buildroot} ${specfile} >${logfile} 2>&1
-  fi
-  ${ECHO} rm -rf ${dst}/../BUILD/${target}-binutils*
-  ${ECHO} rm -rf ${buildroot}/opt
+  rpm -ba --buildroot=/opt/tmp \
+     ${dst}/${target}-binutils.spec >log/${target}-binutils 2>&1
+  rm -rf ${dst}/../BUILD/${target}-binutils
+  rm -rf /opt/tmp/opt
 
   # now build gdb
-  logfile=log/${target}-gdb
-  specfile=${dst}/${target}-gdb-${gdb}.spec
-  echo "rpm -ba --buildroot=${buildroot} ${specfile} >${logfile} 2>&1"
-  if [ ${testing} = no ] ; then
-    rpm -ba --buildroot=${buildroot} ${specfile} >${logfile} 2>&1
-  fi
-  ${ECHO} rm -rf ${dst}/../BUILD/${target}-gdb*
-  ${ECHO} rm -rf ${buildroot}/opt
+  rpm -ba --buildroot=/opt/tmp \
+     ${dst}/${target}-gdb.spec >log/${target}-gdb 2>&1
+  rm -rf ${dst}/../BUILD/${target}-gdb
+  rm -rf /opt/tmp/opt
 
   # now build gcc/newlib
   #    NOTE: This requires having binutils installed and we immediately
   #          remove it once finished.
-  ${ECHO} rpm -i ${dst}/../RPMS/i386/${target}-binutils-${binutils}-0.i386.rpm
+  rpm -i ${dst}/../RPMS/i386/${target}-binutils-19991011-0.i386.rpm
 
-  logfile=log/${target}-gccnewlib
-  specfile=${dst}/${target}-gcc-${gcc}-newlib-${newlib}.spec
-  echo "rpm -ba --buildroot=${buildroot} ${specfile} >${logfile} 2>&1"
-  if [ ${testing} = no ] ; then
-    rpm -ba --buildroot=${buildroot} ${specfile} >${logfile} 2>&1
-  fi
-  ${ECHO} rm -rf ${dst}/../BUILD/${target}-gcc*
-  ${ECHO} rm -rf ${buildroot}/opt
+  rpm -ba --buildroot=/opt/tmp \
+     ${dst}/${target}-gcc_newlib.spec >log/${target}-gccnewlib 2>&1
+  rm -rf ${dst}/../BUILD/${target}-gcc_newlib
+  rm -rf /opt/tmp/opt
 
-  echo uninstalling binutils for ${target} 
-  if [ ${testing} = no ] ; then
-    rpm -e `rpm -qa | grep rtems`
-  fi
+  rpm -e `rpm -qa | grep rtems`
 done
 
-staging_dir=/usr3/rtems_cds/test_cd/linux
+mv ${dst}/../RPMS/i386/*.rpm /usr3/rtems_cds/test_cd/RPMS
+mv ${dst}/../SRPMS/*.rpm /usr3/rtems_cds/test_cd/SRPMS
 
-${ECHO} mkdir ${staging_dir}
-${ECHO} mkdir ${staging_dir}/RPMS
-${ECHO} mkdir ${staging_dir}/SRPMS
-
-echo Moving RPMs to CD staging directory
-for file in `ls -1 ${dst}/../RPMS/i386/*.rpm 2>/dev/null`
-do
-  ${ECHO} mv ${file} ${staging_dir}/RPMS
-done
-
-echo Moving SRPMs to CD staging directory
-for file in `ls -1 ${dst}/../SRPMS/*.rpm 2>/dev/null`
-do
-  ${ECHO} mv ${file} ${staging_dir}/SRPMS
-done
-
-# Now we are done
-
-stop=`date`
-
-echo
-echo "Started:  " $start
-echo "Finished: " $stop
 exit 0
Index: scripts/configure.in
===================================================================
--- scripts/configure.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/configure.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,40 @@
+AC_INIT(binutils)
+AM_INIT_AUTOMAKE(scripts,19991020-0,no)
+
+test -f ./setup.cache || cp ./setup.def ./setup.cache
+. ./setup.cache
+
+# Some linux distributions use /usr/src/packages
+# redhat uses /usr/src/redhat
+# others might use /usr/src
+AC_MSG_CHECKING(for rpm SPECS directory)
+if test -d /usr/src/packages/SPECS;
+then
+RPM_SPECSdir=/usr/src/packages/SPECS;
+elif test -d /usr/src/redhat/SPECS;
+then
+RPM_SPECSdirs=/usr/src/redhat/SPECS;
+elif test -d /usr/src/SPECS/;
+then
+RPM_SPECSdir=/usr/src/SPECS;
+fi
+if test x"$RPM_SPECSdir" = x; then
+AC_MSG_ERROR(not found)
+fi
+AC_MSG_RESULT($RPM_SPECSdir)
+AC_SUBST(RPM_SPECSdir)
+
+GCCNEWLIBVERS="gcc-${gcc_version}-newlib-${newlib_version}"
+AC_SUBST(GCCNEWLIBVERS)
+BINUTILSVERS="binutils-${binutils_version}"
+AC_SUBST(BINUTILSVERS)
+GDBVERS="gdb-${gdb_version}"
+AC_SUBST(GDBVERS)
+
+AC_OUTPUT(
+Makefile
+mkbinutilspec
+mkgccnewlibspec
+binutils/Makefile
+gccnewlib/Makefile
+)
Index: scripts/gccnewlib.spec.in
===================================================================
--- scripts/gccnewlib.spec.in	(revision 1410dc36c7be2618992a5c1a6770ae8958bfe33f)
+++ scripts/gccnewlib.spec.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -6,6 +6,4 @@
 # please send bugfixes or comments to joel@OARcorp.com
 #
-
-# neededforbuild  @target_alias@-binutils @target_alias@-gcc
 
 Vendor:       OAR Corporation
@@ -40,5 +38,5 @@
 
 %prep
-# untar the sources inside @target_alias@-gcc-newlib
+# untar the sources inside @target_alias@-gcc-newlib -@Version@
 %setup -c -n @target_alias@-gcc-newlib -a 0 -a 1
 
@@ -49,5 +47,5 @@
 
   # Now link the C library into the source tree 
-  ln -s ../newlib-@newlib_version@/newlib .
+  ln -s ../newlib-1.8.2/newlib .
 )
 
@@ -57,16 +55,8 @@
   ../gcc-@gcc_version@/configure --target=@target_alias@ \
     --with-gnu-as --with-gnu-ld --with-newlib --verbose \
-    --prefix=/opt/rtems 
-
-  test -d $RPM_BUILD_ROOT/opt \
-    || mkdir $RPM_BUILD_ROOT/opt
-  test -d $RPM_BUILD_ROOT/opt/rtems \
-    || mkdir $RPM_BUILD_ROOT/opt/rtems
-  test -d $RPM_BUILD_ROOT/opt/rtems/@target_alias@ \
-    || mkdir $RPM_BUILD_ROOT/opt/rtems/@target_alias@
-  test -d $RPM_BUILD_ROOT/opt/rtems/@target_alias@/include \
-    || mkdir $RPM_BUILD_ROOT/opt/rtems/@target_alias@/include
-  test -d $RPM_BUILD_ROOT/opt/rtems/@target_alias@/sys-include \
-    || mkdir $RPM_BUILD_ROOT/opt/rtems/@target_alias@/sys-include
+    --prefix=/opt/rtems --enable-languages="c c++"
+  ../gcc-@gcc_version@/mkinstalldirs \
+    $RPM_BUILD_ROOT/opt/rtems/@target_alias@/sys-include \
+    $RPM_BUILD_ROOT/opt/rtems/@target_alias@/include
 
   srclimits=../gcc-@gcc_version@/newlib/libc/sys/rtems/include/limits.h
@@ -94,22 +84,32 @@
   cd @target_alias@/newlib
   make prefix=$RPM_BUILD_ROOT/opt/rtems install-info
+# gzip info files
+  gzip -f $RPM_BUILD_ROOT/opt/rtems/info/*.info 2>/dev/null
+  gzip -f $RPM_BUILD_ROOT/opt/rtems/info/*.info-? 2>/dev/null
 )
 
+%post
+  if test -d $RPM_INSTALL_PREFIX/rtems/info; 
+  then
+    rm -f $RPM_INSTALL_PREFIX/rtems/info/dir
+    f=`find $RPM_INSTALL_PREFIX/rtems/info -name '*.info.gz'`
+    test -n "$f" && for i in $f; do
+      install-info $i $RPM_INSTALL_PREFIX/rtems/info/dir
+    done
+  fi
+
+%postun
+  if test -d $RPM_INSTALL_PREFIX/rtems/info; 
+  then
+    rm -f $RPM_INSTALL_PREFIX/rtems/info/dir
+    f=`find $RPM_INSTALL_PREFIX/rtems/info -name '*.info.gz'`
+    test -n "$f" && for i in $f; do
+      install-info $i $RPM_INSTALL_PREFIX/rtems/info/dir
+    done
+  fi
+
 %files
-%dir /opt/rtems
-%dir /opt/rtems/bin
 %dir /opt/rtems/info
-%dir /opt/rtems/lib
-%dir /opt/rtems/lib/gcc-lib
-%dir /opt/rtems/lib/gcc-lib/@target_alias@
-%dir /opt/rtems/lib/gcc-lib/@target_alias@/@gcc_version@
-%dir /opt/rtems/lib/gcc-lib/@target_alias@/@gcc_version@/include
-%dir /opt/rtems/@target_alias@
-%dir /opt/rtems/@target_alias@/include
-%dir /opt/rtems/@target_alias@/sys-include
-%dir /opt/rtems/@target_alias@/lib
-%dir /opt/rtems/man
-%dir /opt/rtems/man/man1
-
+%doc /opt/rtems/info/dir
 %doc /opt/rtems/info/chill.info*
 %doc /opt/rtems/info/cpp.info*
@@ -118,8 +118,12 @@
 %doc /opt/rtems/info/libc.info*
 %doc /opt/rtems/info/libm.info*
+
+%dir /opt/rtems/man
+%dir /opt/rtems/man/man1
 %doc /opt/rtems/man/man1/cccp.1
 %doc /opt/rtems/man/man1/@target_alias@-gcc.1
 %doc /opt/rtems/man/man1/@target_alias@-g++.1
 
+%dir /opt/rtems/bin
 /opt/rtems/bin/cpp
 /opt/rtems/bin/@target_alias@-c++
@@ -127,4 +131,7 @@
 /opt/rtems/bin/@target_alias@-gcc
 /opt/rtems/bin/@target_alias@-gcj
+%dir /opt/rtems/lib
+%dir /opt/rtems/lib/gcc-lib
+%dir /opt/rtems/lib/gcc-lib/@target_alias@
 /opt/rtems/lib/gcc-lib/@target_alias@/@gcc_version@
 /opt/rtems/@target_alias@/include
Index: scripts/gccnewlib/Makefile.am
===================================================================
--- scripts/gccnewlib/Makefile.am	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/gccnewlib/Makefile.am	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,51 @@
+AUTOMAKE_OPTIONS = foreign
+
+MKGCCNEWLIBSPEC = $(SHELL) ../mkgccnewlibspec
+
+MKGCCNEWLIBSPEC_DEPS = \
+  ../mkgccnewlibspec gccnewlib.spec.in ../setup.cache
+
+i386-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . i386-rtems
+
+sh-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . sh-rtems
+
+powerpc-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . powerpc-rtems
+
+sparc-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . sparc-rtems
+
+m68k-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . m68k-rtems
+
+mips64orion-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . mips64orion-rtems
+
+i960-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . i960-rtems
+
+hppa1.1-rtems-$(GCCNEWLIBVERS).spec: $(MKGCCNEWLIBSPEC_DEPS)
+	$(MKGCCNEWLIBSPEC) -cfg ../setup.cache -o . hppa1.1-rtems
+
+TEMPLATES = \
+gccnewlib.spec.in
+
+RPM_SPECS_DATA = \
+i386-rtems-$(GCCNEWLIBVERS).spec \
+sh-rtems-$(GCCNEWLIBVERS).spec \
+powerpc-rtems-$(GCCNEWLIBVERS).spec \
+sparc-rtems-$(GCCNEWLIBVERS).spec \
+m68k-rtems-$(GCCNEWLIBVERS).spec \
+mips64orion-rtems-$(GCCNEWLIBVERS).spec \
+i960-rtems-$(GCCNEWLIBVERS).spec \
+hppa1.1-rtems-$(GCCNEWLIBVERS).spec
+
+noinst_DATA = \
+$(TEMPLATES)
+
+EXTRA_DIST = \
+$(TEMPLATES)
+
+CLEANFILES = $(RPM_SPECS_DATA)
Index: scripts/gccnewlib/gccnewlib.spec.in
===================================================================
--- scripts/gccnewlib/gccnewlib.spec.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/gccnewlib/gccnewlib.spec.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,140 @@
+#
+# spec file for package rtems
+# 
+# Copyright  (c)  1999  OARCorp, Huntsville, AL
+#
+# please send bugfixes or comments to joel@OARcorp.com
+#
+
+Vendor:       OAR Corporation
+Distribution: Linux
+Name:         @target_alias@-gcc-newlib
+Release:      @Release@
+Copyright:    1999 OARCorp
+Group:        unsorted
+Provides:     @target_alias@-gcc-newlib
+Requires:     @target_alias@-binutils
+
+Autoreqprov:  on
+Packager:     corsepiu@faw.uni-ulm.de and joel@OARcorp.com
+
+Version:      gcc@gcc_version@newlib@newlib_version@
+Summary:      rtems gcc and newlib C Library for target @target_alias@
+Source0:	gcc-@gcc_version@.tar.gz
+Source1:	newlib-@newlib_version@.tar.gz
+Patch0:		gcc-@gcc_version@-rtems-@gcc_patch_version@.diff
+Patch1:		newlib-@newlib_version@-rtems-@newlib_patch_version@.diff
+
+Buildroot:    /tmp
+# Patch:
+%description
+RTEMS is an open source operating system for embedded systems.
+
+This is gcc and newlib C Library for @target_alias@.
+
+Authors:
+--------
+    Joel Sherrill (joel@oarcorp.com)
+    ...
+
+%prep
+# untar the sources inside @target_alias@-gcc-newlib -@Version@
+%setup -c -n @target_alias@-gcc-newlib -a 0 -a 1
+
+%patch0 -p0
+%patch1 -p0
+
+( cd gcc-@gcc_version@
+
+  # Now link the C library into the source tree 
+  ln -s ../newlib-1.8.2/newlib .
+)
+
+%build
+test -d build || mkdir build
+( cd build
+  ../gcc-@gcc_version@/configure --target=@target_alias@ \
+    --with-gnu-as --with-gnu-ld --with-newlib --verbose \
+    --prefix=/opt/rtems
+  ../gcc-@gcc_version@/mkinstalldirs \
+    $RPM_BUILD_ROOT/opt/rtems/@target_alias@/sys-include \
+    $RPM_BUILD_ROOT/opt/rtems/@target_alias@/include
+
+  srclimits=../gcc-@gcc_version@/newlib/libc/sys/rtems/include/limits.h
+  for dir in $RPM_BUILD_ROOT/opt/rtems/@target_alias@/include \
+             $RPM_BUILD_ROOT/opt/rtems/@target_alias@/sys-include
+  do
+    cp ${srclimits} ${dir}
+  done
+
+  #make LANGUAGES="c c++" all
+  make all
+  make info
+
+  cd gcc
+    rm -f stmp-multilib
+    find . -name "*.a" -print | xargs -e rm -f
+
+    make all
+  cd ..
+)
+
+%install
+( cd build
+  make prefix=$RPM_BUILD_ROOT/opt/rtems install
+  cd @target_alias@/newlib
+  make prefix=$RPM_BUILD_ROOT/opt/rtems install-info
+# gzip info files
+  gzip -f $RPM_BUILD_ROOT/opt/rtems/info/*.info 2>/dev/null
+  gzip -f $RPM_BUILD_ROOT/opt/rtems/info/*.info-? 2>/dev/null
+)
+
+%post
+  if test -d $RPM_INSTALL_PREFIX/rtems/info; 
+  then
+    rm -f $RPM_INSTALL_PREFIX/rtems/info/dir
+    f=`find $RPM_INSTALL_PREFIX/rtems/info -name '*.info.gz'`
+    test -n "$f" && for i in $f; do
+      install-info $i $RPM_INSTALL_PREFIX/rtems/info/dir
+    done
+  fi
+
+%postun
+  if test -d $RPM_INSTALL_PREFIX/rtems/info; 
+  then
+    rm -f $RPM_INSTALL_PREFIX/rtems/info/dir
+    f=`find $RPM_INSTALL_PREFIX/rtems/info -name '*.info.gz'`
+    test -n "$f" && for i in $f; do
+      install-info $i $RPM_INSTALL_PREFIX/rtems/info/dir
+    done
+  fi
+
+%files
+%dir /opt/rtems/info
+%doc /opt/rtems/info/dir
+%doc /opt/rtems/info/chill.info*
+%doc /opt/rtems/info/cpp.info*
+%doc /opt/rtems/info/gcc.info*
+%doc /opt/rtems/info/g77.info*
+%doc /opt/rtems/info/libc.info*
+%doc /opt/rtems/info/libm.info*
+
+%dir /opt/rtems/man
+%dir /opt/rtems/man/man1
+%doc /opt/rtems/man/man1/cccp.1
+%doc /opt/rtems/man/man1/@target_alias@-gcc.1
+%doc /opt/rtems/man/man1/@target_alias@-g++.1
+
+%dir /opt/rtems/bin
+/opt/rtems/bin/cpp
+/opt/rtems/bin/@target_alias@-c++
+/opt/rtems/bin/@target_alias@-g++
+/opt/rtems/bin/@target_alias@-gcc
+/opt/rtems/bin/@target_alias@-gcj
+%dir /opt/rtems/lib
+%dir /opt/rtems/lib/gcc-lib
+%dir /opt/rtems/lib/gcc-lib/@target_alias@
+/opt/rtems/lib/gcc-lib/@target_alias@/@gcc_version@
+/opt/rtems/@target_alias@/include
+/opt/rtems/@target_alias@/sys-include
+/opt/rtems/@target_alias@/lib
Index: scripts/gdb.spec.in
===================================================================
--- scripts/gdb.spec.in	(revision 1410dc36c7be2618992a5c1a6770ae8958bfe33f)
+++ scripts/gdb.spec.in	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -20,8 +20,8 @@
 Packager:     corsepiu@faw.uni-ulm.de and joel@OARcorp.com
 
-Version:      gdb@gdb_version@
+Version:      @Version@
 Summary:      gdb for target @target_alias@
-Source0:      	gdb-@gdb_version@.tar.gz
-Patch0:		gdb-@gdb_version@-rtems-@gdb_patch_version@.diff
+Source0:      	gdb-4.18.tar.gz
+Patch0:		gdb-4.18-rtems-19991015.diff
 
 Buildroot:    /tmp
@@ -38,5 +38,5 @@
 
 %prep
-# untar the sources inside @target_alias@-gdb
+# untar the sources inside @target_alias@-gdb-@Version@
 %setup -c -n @target_alias@-gdb -a 0
 
@@ -46,5 +46,5 @@
 test -d build || mkdir build
 ( cd build
-  ../gdb-@gdb_version@/configure --target=@target_alias@ \
+  ../gdb-4.18/configure --target=@target_alias@ \
     --verbose --prefix=/opt/rtems 
 
@@ -65,12 +65,4 @@
 
 %files
-%dir /opt/rtems
-%dir /opt/rtems/bin
-%dir /opt/rtems/include
-%dir /opt/rtems/info
-%dir /opt/rtems/lib
-%dir /opt/rtems/man
-%dir /opt/rtems/man/man1
-
 %doc /opt/rtems/info/gdb.info*
 %doc /opt/rtems/info/mmalloc.info*
Index: scripts/install-sh
===================================================================
--- scripts/install-sh	(revision 10629f743599b259f03b74a376cf71f321469e0c)
+++ scripts/install-sh	(revision 10629f743599b259f03b74a376cf71f321469e0c)
@@ -0,0 +1,251 @@
+#!/bin/sh
+#
+# install - install a program, script, or datafile
+# This comes from X11R5 (mit/util/scripts/install.sh).
+#
+# Copyright 1991 by the Massachusetts Institute of Technology
+#
+# Permission to use, copy, modify, distribute, and sell this software and its
+# documentation for any purpose is hereby granted without fee, provided that
+# the above copyright notice appear in all copies and that both that
+# copyright notice and this permission notice appear in supporting
+# documentation, and that the name of M.I.T. not be used in advertising or
+# publicity pertaining to distribution of the software without specific,
+# written prior permission.  M.I.T. makes no representations about the
+# suitability of this software for any purpose.  It is provided "as is"
+# without express or implied warranty.
+#
+# Calling this script install-sh is preferred over install.sh, to prevent
+# `make' implicit rules from creating a file called install from it
+# when there is no Makefile.
+#
+# This script is compatible with the BSD install script, but was written
+# from scratch.  It can only install one file at a time, a restriction
+# shared with many OS's install programs.
+
+
+# set DOITPROG to echo to test this script
+
+# Don't use :- since 4.3BSD and earlier shells don't like it.
+doit="${DOITPROG-}"
+
+
+# put in absolute paths if you don't have them in your path; or use env. vars.
+
+mvprog="${MVPROG-mv}"
+cpprog="${CPPROG-cp}"
+chmodprog="${CHMODPROG-chmod}"
+chownprog="${CHOWNPROG-chown}"
+chgrpprog="${CHGRPPROG-chgrp}"
+stripprog="${STRIPPROG-strip}"
+rmprog="${RMPROG-rm}"
+mkdirprog="${MKDIRPROG-mkdir}"
+
+transformbasename=""
+transform_arg=""
+instcmd="$mvprog"
+chmodcmd="$chmodprog 0755"
+chowncmd=""
+chgrpcmd=""
+stripcmd=""
+rmcmd="$rmprog -f"
+mvcmd="$mvprog"
+src=""
+dst=""
+dir_arg=""
+
+while [ x"$1" != x ]; do
+    case $1 in
+	-c) instcmd="$cpprog"
+	    shift
+	    continue;;
+
+	-d) dir_arg=true
+	    shift
+	    continue;;
+
+	-m) chmodcmd="$chmodprog $2"
+	    shift
+	    shift
+	    continue;;
+
+	-o) chowncmd="$chownprog $2"
+	    shift
+	    shift
+	    continue;;
+
+	-g) chgrpcmd="$chgrpprog $2"
+	    shift
+	    shift
+	    continue;;
+
+	-s) stripcmd="$stripprog"
+	    shift
+	    continue;;
+
+	-t=*) transformarg=`echo $1 | sed 's/-t=//'`
+	    shift
+	    continue;;
+
+	-b=*) transformbasename=`echo $1 | sed 's/-b=//'`
+	    shift
+	    continue;;
+
+	*)  if [ x"$src" = x ]
+	    then
+		src=$1
+	    else
+		# this colon is to work around a 386BSD /bin/sh bug
+		:
+		dst=$1
+	    fi
+	    shift
+	    continue;;
+    esac
+done
+
+if [ x"$src" = x ]
+then
+	echo "install:	no input file specified"
+	exit 1
+else
+	true
+fi
+
+if [ x"$dir_arg" != x ]; then
+	dst=$src
+	src=""
+	
+	if [ -d $dst ]; then
+		instcmd=:
+		chmodcmd=""
+	else
+		instcmd=mkdir
+	fi
+else
+
+# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
+# might cause directories to be created, which would be especially bad 
+# if $src (and thus $dsttmp) contains '*'.
+
+	if [ -f $src -o -d $src ]
+	then
+		true
+	else
+		echo "install:  $src does not exist"
+		exit 1
+	fi
+	
+	if [ x"$dst" = x ]
+	then
+		echo "install:	no destination specified"
+		exit 1
+	else
+		true
+	fi
+
+# If destination is a directory, append the input filename; if your system
+# does not like double slashes in filenames, you may need to add some logic
+
+	if [ -d $dst ]
+	then
+		dst="$dst"/`basename $src`
+	else
+		true
+	fi
+fi
+
+## this sed command emulates the dirname command
+dstdir=`echo $dst | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
+
+# Make sure that the destination directory exists.
+#  this part is taken from Noah Friedman's mkinstalldirs script
+
+# Skip lots of stat calls in the usual case.
+if [ ! -d "$dstdir" ]; then
+defaultIFS='	
+'
+IFS="${IFS-${defaultIFS}}"
+
+oIFS="${IFS}"
+# Some sh's can't handle IFS=/ for some reason.
+IFS='%'
+set - `echo ${dstdir} | sed -e 's@/@%@g' -e 's@^%@/@'`
+IFS="${oIFS}"
+
+pathcomp=''
+
+while [ $# -ne 0 ] ; do
+	pathcomp="${pathcomp}${1}"
+	shift
+
+	if [ ! -d "${pathcomp}" ] ;
+        then
+		$mkdirprog "${pathcomp}"
+	else
+		true
+	fi
+
+	pathcomp="${pathcomp}/"
+done
+fi
+
+if [ x"$dir_arg" != x ]
+then
+	$doit $instcmd $dst &&
+
+	if [ x"$chowncmd" != x ]; then $doit $chowncmd $dst; else true ; fi &&
+	if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dst; else true ; fi &&
+	if [ x"$stripcmd" != x ]; then $doit $stripcmd $dst; else true ; fi &&
+	if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dst; else true ; fi
+else
+
+# If we're going to rename the final executable, determine the name now.
+
+	if [ x"$transformarg" = x ] 
+	then
+		dstfile=`basename $dst`
+	else
+		dstfile=`basename $dst $transformbasename | 
+			sed $transformarg`$transformbasename
+	fi
+
+# don't allow the sed command to completely eliminate the filename
+
+	if [ x"$dstfile" = x ] 
+	then
+		dstfile=`basename $dst`
+	else
+		true
+	fi
+
+# Make a temp file name in the proper directory.
+
+	dsttmp=$dstdir/#inst.$$#
+
+# Move or copy the file name to the temp name
+
+	$doit $instcmd $src $dsttmp &&
+
+	trap "rm -f ${dsttmp}" 0 &&
+
+# and set any options; do chmod last to preserve setuid bits
+
+# If any of these fail, we abort the whole thing.  If we want to
+# ignore errors from any of these, just make sure not to ignore
+# errors from the above "$doit $instcmd $src $dsttmp" command.
+
+	if [ x"$chowncmd" != x ]; then $doit $chowncmd $dsttmp; else true;fi &&
+	if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dsttmp; else true;fi &&
+	if [ x"$stripcmd" != x ]; then $doit $stripcmd $dsttmp; else true;fi &&
+	if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dsttmp; else true;fi &&
+
+# Now rename the file to the real destination.
+
+	$doit $rmcmd -f $dstdir/$dstfile &&
+	$doit $mvcmd $dsttmp $dstdir/$dstfile 
+
+fi &&
+
+
+exit 0
